package hr.fer.zemris.seminar.ajnc;

import java.util.Random;

public class RandomMultiDeck {
	private int numberOfDecks;
	private int[] cardUsed = new int[13];
	
	private int index;
	private int[] actualDeck;
	
	public RandomMultiDeck(int numberOfDecks) {
		this.numberOfDecks = numberOfDecks;
		this.actualDeck = new int[52*numberOfDecks];
		generateRandomDeck();
		this.index = 0;
	}

	private void generateRandomDeck() {
		for (int i =0; i < cardUsed.length; i++)
			cardUsed[i] = numberOfDecks*4;
		
		int indexForPopulating = 0;
		
		while (!allCardUsed()) {
			int numberGot = new Random().nextInt(13);
			if (cardUsed[numberGot] == 0)
				continue;
			
			this.actualDeck[indexForPopulating] = numberGot;
			cardUsed[numberGot]--;
			indexForPopulating++;
		}
		
		System.out.println("Deck with "+ indexForPopulating +" cards generated!");
	}
	
	private boolean allCardUsed() {
		for (int i = 0; i <cardUsed.length; i++)
			if (cardUsed[i] > 0)
				return false;
		return true;
	}

	public int drawNextCard() {
		index++;
		return actualDeck[index-1];
	}
	
}
